Subject: Re: [PATCH] gmac: sun8i: r40: add gmac tx_delay support

From: fuyao <[email-masked]>
Date: Thu, 21 Dec 2023 15:16:54 +0800

On Wed, Dec 20, 2023 at 06:04:28PM +0100, Jernej Škrabec wrote:
> Dne sreda, 20. december 2023 ob 10:08:25 CET je fuyao napisal(a):
> > r40 can support tx_delay, so we add it.
> 
> I don't see how. User manual, 3.3.4.64. GMAC Clock Register talks only
> about RX delay.
> 

I don't see it in the user manual also.

it works fine in 100M, but it doesn't work good in 1G without tx_delay
in my board.

Read the sdk from allwinner I found in:

https://sourcegraph.com/github.com/tinalinux/linux-3.10/-/blob/arch/arm/boot/dts/sun8iw11p1.dtsi?L1826
https://sourcegraph.com/github.com/tinalinux/[email-masked]/-/blob/drivers/net/ethernet/allwinner/sunxi-gmac.c?L877

And I add it to my board, it works fine.

So, I think it may be exist register but not documented.

Best regards,
fuyao

> Best regards,
> Jernej
> 
> > 
> > Signed-off-by: fuyao <[email-masked]>
> > ---
> >  drivers/net/ethernet/stmicro/stmmac/dwmac-sun8i.c | 1 +
> >  1 file changed, 1 insertion(+)
> > 
> > diff --git a/drivers/net/ethernet/stmicro/stmmac/dwmac-sun8i.c b/drivers/net/ethernet/stmicro/stmmac/dwmac-sun8i.c
> > index 137741b94122..fd07573afc9b 100644
> > --- a/drivers/net/ethernet/stmicro/stmmac/dwmac-sun8i.c
> > +++ b/drivers/net/ethernet/stmicro/stmmac/dwmac-sun8i.c
> > @@ -127,6 +127,7 @@ static const struct emac_variant emac_variant_r40 = {
> >  	.support_mii = true,
> >  	.support_rgmii = true,
> >  	.rx_delay_max = 7,
> > +	.tx_delay_max = 7,
> >  };
> >  
> >  static const struct emac_variant emac_variant_a64 = {
> > 
> 
> 
> 
>